

(* *********************************************************************** *)
(** * Other proofs *)

(* side: gather atoms doesn't know about [atom * atom]. *)

(* have to encode possibilities for every number of implicit arguments. *)

Ltac swapify :=
  repeat (match goal with
            | H : context [?f ?ab ?x] |- _ =>
              progress change (f ab x) with (swap ab x) in H
            | H : context [?f ?X1 ?X2 ?ab ?x] |- _ =>
              progress change (f X1 X2 ab x) with (swap ab x) in H
            | |- context [?f ?ab ?x] =>
              progress change (f ab x) with (swap ab x)
            | |- context [?f ?X1 ?X2 ?ab ?x] =>
              progress change (f X1 X2 ab x) with (swap ab x)
          end).

Lemma typing_equivariant : forall G e T ab,
  typing G e T ->
  typing (swap ab G) (swap ab e) (swap ab T).
Proof.
  induction 1; simpl in *; swapify.
  3:eauto.
  (* var case: requires that we show binds and uniq are equiv. *)
  (* abs case: requires that we show `notin`, open are equiv. *)
  Focus 2.
  pick fresh x and apply typing_abs.
  specialize (H0 (swap ab x)).
  simpl in *; swapify.
  Hint Rewrite swap_invol swap_same : lngen.
  autorewrite with lngen in *.
